#include <amxmodx>
#include <dhudmessage>
#include <fakemeta>

new health_add, health_hs_add, health_max, color_r, color_g, color_b, alpha, kill_progress, kills[33]
new hud, d_hud, hud_color_r, hud_color_g, hud_color_b
new nKiller,nKiller_hp, nHp_add, nHp_max
new vip_health_add, vip_health_hs_add, vip_health_max, vip_enabled
new bool:vip[33] = false

public plugin_init()
{
	register_plugin("Vampire", "1.1", "fixes by UrShade")

	//Основные квары
	health_add = register_cvar("amx_vampire_hp", "")
	health_hs_add = register_cvar("amx_vampire_hp_hs", "")
	health_max = register_cvar("amx_vampire_max_hp", "")
	kill_progress = register_cvar("amx_vampire_progress", "")

	//Вип квары
	vip_enabled = register_cvar("amx_vampire_vip", "")
	vip_health_add = register_cvar("amx_vampire_hp_vip", "")
	vip_health_hs_add = register_cvar("amx_vampire_hp_hs_vip", "")
	vip_health_max = register_cvar("amx_vampire_max_hp_vip", "")

	//Квары цвета скринфэйда
	color_r = register_cvar("amx_vampire_red", "")
	color_g = register_cvar("amx_vampire_green", "")
	color_b = register_cvar("amx_vampire_blue", "")
	alpha = register_cvar("amx_vampire_alpha", "")

	//Квары худа
	hud = register_cvar("amx_vampire_hud", "")
	d_hud = register_cvar("amx_vampire_dhud", "")
	hud_color_r = register_cvar("amx_vampire_hud_r", "")
	hud_color_g = register_cvar("amx_vampire_hud_g", "")
	hud_color_b = register_cvar("amx_vampire_hud_b", "")

	register_event("DeathMsg", "hook_death", "a", "1>0") 	
}

public plugin_cfg()
{
	new g_Cfg[128]
	get_localinfo("amxx_configsdir", g_Cfg, charsmax(g_Cfg))
	server_cmd("exec %s/urshade/vampire.cfg", g_Cfg)
}

public client_putinserver(id)
{
	if((get_user_flags(id) & ADMIN_LEVEL_H) && (get_pcvar_num (vip_enabled) == 1))
		vip[id] = true
}

public csdm_PostSpawn(id)
{
	kills[id] = 0
}
public hook_death()
{
	nKiller = read_data(1)
	kills[nKiller]++
	if(vip[nKiller]){
		if (read_data(3))
			nHp_add = get_pcvar_num (vip_health_hs_add)
		else
			nHp_add = get_pcvar_num (vip_health_add)
		nHp_max = get_pcvar_num (vip_health_max)
	}else{
		if (read_data(3))
			nHp_add = get_pcvar_num (health_hs_add)
		else
			nHp_add = get_pcvar_num (health_add)
		nHp_max = get_pcvar_num (health_max)	
	}

	nKiller_hp = pev(nKiller,pev_health)

	if((kills[nKiller] > 0) && (get_pcvar_num (kill_progress) == 1))
		nKiller_hp = nKiller_hp + nHp_add + (kills[nKiller] + 3)
	else 
		nKiller_hp += nHp_add

	if (nKiller_hp > nHp_max)
		nKiller_hp = nHp_max

	if(get_pcvar_num(hud) == 1)
		show_hud(nKiller)

	set_pev(nKiller,pev_health,float(nKiller_hp))

	// Screen fading
	message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, nKiller)
	write_short(1<<10)
	write_short(1<<10)
	write_short(0x0000)
	write_byte(get_pcvar_num(color_r))
	write_byte(get_pcvar_num(color_g))
	write_byte(get_pcvar_num(color_b))
	write_byte(get_pcvar_num(alpha))
	message_end()
}

public show_hud(id)
{
	if(get_pcvar_num(d_hud) == 1){
		set_dhudmessage(get_pcvar_num(hud_color_r), get_pcvar_num(hud_color_g), get_pcvar_num(hud_color_b), -1.0, 0.15, 0, 1.0, 1.0, 0.1, 0.1)
		if((kills[id] >0) && (get_pcvar_num (kill_progress) == 1))
			show_dhudmessage(id, "%d Kills. +%d hp", kills[id], nHp_add + (kills[nKiller] + 3))
		else
			show_dhudmessage(id, "+%d hp", nHp_add)
	}else{
		set_hudmessage(get_pcvar_num(hud_color_r), get_pcvar_num(hud_color_g), get_pcvar_num(hud_color_b), -1.0, 0.15, 0, 1.0, 1.0, 0.1, 0.1, -1)
		if((kills[id] >0) && (get_pcvar_num (kill_progress) == 1))
			show_dhudmessage(id, "%d Kills. +%d hp", kills[id], nHp_add + (kills[nKiller] + 3))
		else
			show_dhudmessage(id, "+%d hp", nHp_add)
	}
}
